package openchat.servidor;

import java.net.*;
import java.io.*;
import java.util.*;
import openchat.bd.BancoDados;

public class ServidorOpenChat
{
	public ServidorOpenChat(int PortServer, String HostMySQL, int PortMySQL)
	{
		try {
			ServerSocket canal = new ServerSocket(PortServer);
			
			for(;;) {
				System.out.println("\n\t[ Servidor OpenChat :: Porta " + PortServer + " ]");
				Socket receive = canal.accept();
				new Order(receive, HostMySQL, PortMySQL).start();
			}
		}
		catch(Exception E) {
			System.err.println("Erro: canal de comunicacao::SERVEROPENCHAT" + E.getMessage());
		}
			
	}
}

class Order extends Thread
{
	private Socket Msg;
	private int Port;
	private String Host;
	private BufferedReader  E;
	private StringTokenizer P;
	private PrintWriter Saida;
	private BancoDados BD;
	private EnviarMensagem SM;
	private String Token="###";
	
	public Order(Socket receive,String HostMySQL,int PortMySQL)
	{
		this.Msg = receive;
		BD = new BancoDados(HostMySQL,PortMySQL);
		SM = new EnviarMensagem(HostMySQL,PortMySQL);
	}
	
	public void run()
	{
		try
		{
			E = new BufferedReader (new InputStreamReader (this.Msg.getInputStream()));
			P = new StringTokenizer (E.readLine (),Token);
			Saida = new PrintWriter (new OutputStreamWriter(this.Msg.getOutputStream()));
		}
		catch(Exception E)
		{
			System.out.println("Erro ao instanciar socket de reposta ao cliente");
		}	
	
	try{
		String Req = P.nextToken();
		System.out.println("Cliente Conectado :: "+Req);
		
		if(Req.equals("NewUser"))
		{
			String Login = P.nextToken();
			String Email = P.nextToken();
			String Name = P.nextToken();
			String Password = P.nextToken();
			String City = P.nextToken();
			String Info = P.nextToken();
			
			Saida.print(BD.NewUser(Login,Email,Name,Password,City,Info));
			Saida.flush();
		}
	
		if(Req.equals("QtUsers"))
		{
			int Id = Integer.parseInt(P.nextToken());
			
			Saida.flush();
		}		
		
		if(Req.equals("Login"))
		{
			
			int Id = Integer.parseInt(P.nextToken());
			String Pass = P.nextToken();
			
			int Port = Integer.parseInt(P.nextToken());
			String Ip = Msg.getInetAddress().getHostAddress();
			
			String Test = ""+BD.UserLogin(Id,Pass,Ip,Port);
			
			Saida.print(Test);
			Saida.flush();			
			
			if(Test.equals("true"))
			{
				StringTokenizer UserOn = new StringTokenizer(BD.ReturnContactList(Id), Token);
				UserOn.nextToken();

				int IdContact;
				String IpContact;
				
				while(UserOn.hasMoreTokens())
				{
					IdContact = Integer.parseInt(UserOn.nextToken());
					UserOn.nextToken();
					IpContact = UserOn.nextToken();
					UserOn.nextToken();
					
					if(!IpContact.equals("0"))
						new UpdateList(IpContact,BD.ReturnUserPort(IdContact)).start();
						
				}
			}
			
		}
		
		if(Req.equals("Logout"))
		{
			int Id = Integer.parseInt(P.nextToken());
			String Pass = P.nextToken();
			
			String Test = ""+BD.UserLogout(Id,Pass);
			
			Saida.print(Test);
			Saida.flush();
			
			
			if(Test.equals("true"))
			{
				StringTokenizer UserOff = new StringTokenizer(BD.ReturnContactList(Id), Token);

				UserOff.nextToken();
				int IdContact;
				String IpContact;

				while(UserOff.hasMoreTokens())
				{
					IdContact = Integer.parseInt(UserOff.nextToken());
					UserOff.nextToken();
					IpContact = UserOff.nextToken();
					////com a adicao da porta,  necessria essa linha....
					UserOff.nextToken();
					if(!IpContact.equals("0"))
						new UpdateList(IpContact,BD.ReturnUserPort(IdContact)).start();
				}
			}
		}
		
		if(Req.equals("DeleteUser"))
		{
			int Id = Integer.parseInt(P.nextToken());
			String Pass = P.nextToken();
			
			Saida.print(BD.DeleteUser(Id,Pass));
			Saida.flush();
		}
		
		if(Req.equals("UpdateUser"))
		{
			int Id = Integer.parseInt(P.nextToken());
			String Password = P.nextToken();
			String Login = P.nextToken();
			String Email = P.nextToken();
			String Name = P.nextToken();
			String City = P.nextToken();
			String Info = P.nextToken();
			
			Saida.print(BD.UpdateUser(Id,Login,Email,Name,Password,City,Info));
			Saida.flush();
		}		
		
		if(Req.equals("ReturnUserLogin"))
		{
			int Id = Integer.parseInt(P.nextToken());
			Saida.print(BD.ReturnUserLogin(Id));
			Saida.flush();
		}
		
		if(Req.equals("ReturnUserIp"))
		{
			int Id = Integer.parseInt(P.nextToken());
			Saida.print(BD.ReturnUserIp(Id));
			Saida.flush();
		}
		
		if(Req.equals("ReturnUserName"))
		{
			int Id = Integer.parseInt(P.nextToken());
			Saida.print(BD.ReturnUserName(Id));
			Saida.flush();
		}
		
		if(Req.equals("ReturnUserEmail"))
		{
			int Id = Integer.parseInt(P.nextToken());
			Saida.print(BD.ReturnUserEmail(Id));
			Saida.flush();
		}
		
		if(Req.equals("ReturnUserInfo"))
		{
			int Id = Integer.parseInt(P.nextToken());
			Saida.print(BD.ReturnUserInfo(Id));
			Saida.flush();
		}
		
		if(Req.equals("ReturnUserCity"))
		{
			int Id = Integer.parseInt(P.nextToken());
			Saida.print(BD.ReturnUserCity(Id));
			Saida.flush();
		}
		
		if(Req.equals("ReturnUserId"))
		{
			String Email = P.nextToken();
			
			Saida.print(BD.ReturnUserId(Email));
			Saida.flush();
		}
		
		if(Req.equals("ReturnUserPort"))
		{
			int Id = Integer.parseInt(P.nextToken());
			Saida.print(BD.ReturnUserPort(Id));
			Saida.flush();
		}
				
		if(Req.equals("TestUserIdent"))
		{
			int Id = Integer.parseInt(P.nextToken());
			String Pass = P.nextToken();
			
			Saida.print(BD.TestUserIdent(Id,Pass));
			Saida.flush();
		}
		
		if(Req.equals("ReturnUserContactInformation"))
		{
			int Id = Integer.parseInt(P.nextToken());
			
			String Information = BD.ReturnUserLogin(Id)+Token+
					BD.ReturnUserEmail(Id)+Token+
					BD.ReturnUserCity(Id)+Token+
					BD.ReturnUserName(Id)+Token+
					BD.ReturnUserInfo(Id)+Token;
						
			
			Saida.print(Information);
			Saida.flush();
			
		}
			
		if(Req.equals("ExistUser"))
		{
			int Id = Integer.parseInt(P.nextToken());
			Saida.print(BD.ExistUser(Id));
			Saida.flush();
		}
		
		if(Req.equals("AddContact"))
		{
			int Id = Integer.parseInt(P.nextToken());
			int Contact = Integer.parseInt(P.nextToken());
				
			Saida.print(BD.AddUserContact(Id,Contact));
			Saida.flush();
		}
		
		if(Req.equals("DeleteContact"))
		{
			int Id = Integer.parseInt(P.nextToken());
			int Contact = Integer.parseInt(P.nextToken());
			
			Saida.print(BD.DeleteUserContact(Id,Contact));
			Saida.flush();
		}
		
		if(Req.equals("SendMessage"))
		{
			int IdFrom = Integer.parseInt(P.nextToken());
			int IdTo = Integer.parseInt(P.nextToken());
			
			String Msg = "";
			
			try{
			for (;;)
			{
				Msg = Msg + E.readLine();
				if(E.ready())
					Msg = Msg + '\n';
				else
					break; // caso nao existam, sair do loop de montagem da mensagem
			}
			
			}
			catch(Exception E)
			{
				System.out.println("ERRO NO FOR SENDMESSAGE :"+E.getMessage());
			}
			
			
			Saida.print(SM.SendTo(IdFrom, IdTo, Msg));
			Saida.flush();
		}
			
		if(Req.equals("ExistContactUser"))
		{
			int Id = Integer.parseInt(P.nextToken());
			int Contact = Integer.parseInt(P.nextToken());
			
			Saida.print(BD.ExistContactUser(Id,Contact));
			Saida.flush();
		}
		
		if(Req.equals("ReturnContactList"))
		{
			int Id = Integer.parseInt(P.nextToken());
			
			Saida.print(BD.ReturnContactList(Id));
			Saida.flush();
		}
		
		if(Req.equals("ReturnUsers"))
		{
			int option = Integer.parseInt(P.nextToken());
			Saida.print(BD.ReturnUsers(option));
			Saida.flush();
		}
	
	}
	catch(Exception NotFound)
	{
		System.err.println("Requisicao invalida");
	}
		try
		{
			E.close ();
			Saida.close ();
			Msg.close ();
		}
		catch(Exception E)
		{
			System.out.println("erro ao fechar socket do servidor");
		}
		
	}
}

class UpdateList extends Thread
{
	private String Up="List", Token="###", IpTo;
	private int PortTo;
		
	public UpdateList(String IpTo, int PortTo)
	{
		this.IpTo = IpTo;
		this.PortTo = PortTo;
	}
	
	
	public void run()
	{
		try{
		
		Socket MSG = new Socket(IpTo,PortTo);
		PrintWriter Send = new PrintWriter(MSG.getOutputStream());
		
		//System.out.println("UpdateList   "+IpTo+"    "+PortTo);
		Send.print(Up+Token);
		Send.flush();
		
		
		
		Send.close();
		Send = null;
		MSG.close();
		MSG = null;
		}
		catch(Exception UP)
		{
			System.out.println("errro atualizando lista: "+UP.getMessage());
		}
	}
}
				
				
